<template>
  <div class="main-container">
    <div class="notice-container">
      Notice:
      <ul>
        <li>There is now GUI way for resource CRUD, please use APIs with postman collection in server code and also in
          <a href="https://google.com" target="_blank">README</a>
        </li>
        <li>Help :
          <ul style="max-width: 150px; text-align: center; padding: 1px 1px">
            <li v-for="(cur, key) in usersColors" :key="key" :style="{backgroundColor: cur.color}"> userId :  {{cur.userId}} </li>
          </ul>
        </li>
        <li class="input-container">
          <input id="event_id" type="number" class="input" v-model="eventId"/>
          <button @click="loadData">Load Data</button>
        </li>
      </ul>

    </div>
    <div v-if="eventData" class="theater-container theme-background-border">
      <h3>Theater : {{ eventData && eventData.theater && eventData.theater.name }}</h3>
      <div v-for="(section, key) in eventData && eventData.theater && eventData.theater.sections" :key="key"
           class="section">
        <h4>Section: {{ section.name }} with order {{ section.order_in_theater }}</h4>
        <div class="row-container">
          <div v-for="(row, key2) in section.rows" :key="key2" class="row theme-background-border">
            <div style="flex: 1">{{ row.name }}</div>
            <div style="flex: 10" class="seats-container">
              <div style="flex: 1" v-for="seat in row.seats" :key="seat.id">
                <div v-if="findBookedSeat(seat.id)"
                     :style="{
                  backgroundColor: getUserColor(findBookedSeat(seat.id).user).color,
                  textAlign: 'center',
                  margin: '1px 1px'
                }"
                >{{seat.name}}</div>
                <div v-else >{{seat.name}}</div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios'

const getRandomColor = function () {
  var letters = '0123456789ABCDEF';
  var color = '#';
  for (var i = 0; i < 6; i++) {
    color += letters[Math.floor(Math.random() * 16)];
  }
  return color;
};

export default {
  name: 'App',
  components: {},
  data() {
    return {
      eventId: "",
      eventData: undefined,
      usersColors: []
    }
  },
  methods: {
    async loadData() {
      try {
        if (this.eventId === '') {
          window.alert('please provide a valid event id')
        }
        const res = await axios.get(`http://localhost:8003/api/v1/booked-event/${this.eventId}`)
        this.eventData = res.data?.data
      } catch (e) {
        console.log(e)
      }

    },
    getUserColor(userId) {
      const foundUser = this.usersColors.find(x => x.userId === userId)

      if (!foundUser)
        this.usersColors = [...this.usersColors, {
          userId,
          color: getRandomColor()
        }]
      return foundUser

    },
    findBookedSeat(seatId){
      console.log(this.eventData.booked_events.length)
      return this.eventData.booked_events.find(x => x.seat.id === seatId)
    }
  }
}
</script>

<style>
#app {
}

body {
  background-color: rgba(215, 215, 215, 0.11);
}

.main-container {
  display: flex;
  flex-direction: column;
  gap: 10px;
}

.notice-container {
  border: gray 1px solid;
  border-radius: 2px;
  padding: 10px;
  background-color: #e5e5e5;
}

.notice-container ul {
  list-style: none;
}

.notice-container ul li {
  margin: 12px;
}

.theater-container {
  padding: 10px;
}

.input {
  font-size: 18px;
}

.input-container {
  display: flex;
  flex-direction: row;
  gap: 10px;
}

.theme-background-border {
  border: gray 1px solid;
  border-radius: 2px;
  padding: 10px;
  background-color: #e5e5e5;
}

.row {
  display: flex;
  flex-direction: row;
}

.row-container {
  display: flex;
  flex-direction: column;
  gap: 10px;
}

.seats-container {
  display: flex;
  flex-direction: row;
  flex-wrap: wrap;
}

</style>
